'use strict';

exports.__esModule = true;
exports.saveState = saveState;
exports.readState = readState;

var _reactNative = require('react-native');

function saveState(key, state, callback) {
  _reactNative.AsyncStorage.setItem(key, JSON.stringify(state), callback);
}

function readState(key, callback) {
  _reactNative.AsyncStorage.getItem(key, function (error, result) {
    if (error || result == null) {
      callback(error, result);
    } else {
      try {
        callback(null, JSON.parse(result));
      } catch (error) {
        callback(null, null); // Ignore invalid JSON.
      }
    }
  });
}